%load elba data
load('parameters.mat')
load('treegrowth.mat')
load('elbadataprocessed.mat','insideBound','vegzonesnew','vegetation','altitudenew','smeltingsitedata', 'agriculture','settlements','elbaregions')
%load('smeltingsitesdata.mat')
load('woodvolage.mat')



%number of wood cells in each region
r1=length(find(elbaregions==11));
r2=length(find(elbaregions==12));
r3=length(find(elbaregions==13));
r4=length(find(elbaregions==14));
r5=length(find(elbaregions==21));
r6=length(find(elbaregions==22));
r7=length(find(elbaregions==23));
r8=length(find(elbaregions==31));
r9=length(find(elbaregions==32));
r10=length(find(elbaregions==33));
r11=length(find(elbaregions==41));
r12=length(find(elbaregions==42));
total=r1+r2+r3+r4+r5+r6+r7+r8+r9+r10+r11+r12;

elbasetting4;

%load altitude
sizealt=size(altitudenew);

%velocity in kmh depending on slope
v=@(x)6*exp(-3.5*abs(x+0.05)); %toblers hiking fct
%subject weight
W=65;
%load weights
Lreturn=35;
Lleave=5;
%terrain coefficient
nu=1.5;
%calculate distance matrix for all sites
ematrix=1; %0=calculate distance matrix,1=load distance matrix
%include workforce
workforce=0;
if ematrix==1
    load('energymatrix.mat','energymatrix1')
    if workforce==1
        load('energymatrix.mat','energymatrix2')
    end
end



if ematrix==0
    energymatrix1=zeros(sizealt(1),sizealt(2),amountsites);
    energymatrix2=zeros(sizealt(1),sizealt(2),amountsettlements);
    for k=1:amountsites
        setupprogress=k/amountsites;
        %get position and altitude of site
        currentsite=smeltingsites(k,3:4);
        origin=[currentsite(2),currentsite(1)];
        altsite=altitudenew(origin(1),origin(2));
        for i=1:sizealt(1)
            for j=1:sizealt(2)
                %distance between node and site in km
                d=(norm([i,j]-origin)*10)/1000;
                if insideBound(i,j)==1
                    %average slope between node and site
                    S=(altitudenew(i,j)-altsite)/(1000*d);
                    %for poisitive slopes correction term is added for return
                    if S>=0
                        %metabolic rates for getting wood
                        M1=1.5*W+2*(W+Lleave)*(Lleave/W).^2+nu*(W+Lleave)*(1.5*v(S)^2+0.35*v(S)*S);
                        M2=1.5*W+2*(W+Lreturn)*(Lreturn/W).^2+nu*(W+Lreturn)*(1.5*v(-S)^2+0.35*v(-S)*-S);%-nu*(v(-S)*-S*(W+Lreturn)/3.5-(W+Lreturn)*(-S+6).^2/W+(25-v(-S).^2));
                        %energymatrix contains total Energy for the journey(E/h*km*h/km)
                        energymatrix1(i,j,k)=M1*d/v(S)+M2*d/v(S);
    %                     if energymatrix(i,j,k)>30000
    %                         
    %                         energymatrix(i,j,k)=30000;
    %                     end
                    else
                        M1=1.5*W+2*(W+Lleave)*(Lleave/W).^2+nu*(W+Lleave)*(1.5*v(S)^2+0.35*v(S)*S);%-nu*( v(S)*S*(W+Lleave)/3.5 - (W+Lleave)*(S+6).^2/W + (25-v(S).^2) );
                        M2=1.5*W+2*(W+Lreturn)*(Lreturn/W).^2+nu*(W+Lreturn)*(1.5*v(-S)^2+0.35*v(-S)*-S);
                        energymatrix1(i,j,k)=M1*d/v(S)+M2*d/v(S);
    %                     if energymatrix(i,j,k)>30000
    %                         
    %                         energymatrix(i,j,k)=30000;
    %                     end
                    end
                else
                    energymatrix1(i,j,k)=NaN;
                end
            end
        end

    end
    if workforce==1
%calculate distance matrix for setllements    
        for k=1:amountsettlements
            %progress=k/amountsettlements
            %get position and altitude of site
            currentsite=settlements(k,1:2);
            origin=[currentsite(2),currentsite(1)];
            altsite=altitudenew(origin(1),origin(2));
            for i=1:dim1
                for j=1:dim2
                    %distance between node and site in km
                    d=(norm([i,j]-origin)*10)/1000;
                    if insideBound(i,j)==1
                        %average slope between node and site
                        S=(altitudenew(i,j)-altsite)/(1000*d);
                        %for poisitive slopes correction term is added for return
                        if S>=0
                            %metabolic rates for getting wood
                            M1=1.5*W+2*(W+Lleave)*(Lleave/W).^2+nu*(W+Lleave)*(1.5*v(S)^2+0.35*v(S)*S);
                            M2=1.5*W+2*(W+Lreturn)*(Lreturn/W).^2+nu*(W+Lreturn)*(1.5*v(-S)^2+0.35*v(-S)*-S);%-nu*(v(-S)*-S*(W+Lreturn)/3.5-(W+Lreturn)*(-S+6).^2/W+(25-v(-S).^2));
                            %energymatrix contains total Energy for the journey(E/h*km*h/km)
                            energymatrix2(i,j,k)=M1*d/v(S)+M2*d/v(S);
        %                     if energymatrix(i,j,k)>30000
        %                         
        %                         energymatrix(i,j,k)=30000;
        %                     end
                        else
                            M1=1.5*W+2*(W+Lleave)*(Lleave/W).^2+nu*(W+Lleave)*(1.5*v(S)^2+0.35*v(S)*S);%-nu*( v(S)*S*(W+Lleave)/3.5 - (W+Lleave)*(S+6).^2/W + (25-v(S).^2) );
                            M2=1.5*W+2*(W+Lreturn)*(Lreturn/W).^2+nu*(W+Lreturn)*(1.5*v(-S)^2+0.35*v(-S)*-S);
                            energymatrix2(i,j,k)=M1*d/v(S)+M2*d/v(S);
        %                     if energymatrix(i,j,k)>30000
        %                         
        %                         energymatrix(i,j,k)=30000;
        %                     end
                        end
                    else
                        energymatrix2(i,j,k)=NaN;
                    end
                end
            end

        end
    end
end

searchindices=zeros(amountsites,dim1*dim2);
for i=1:amountsites
    [bla,I]=sort(reshape(squeeze(energymatrix1(:,:,i)),1,dim1*dim2));
    searchindices(i,:)=I;
end

if workforce==1
    settleindices=zeros(amountsettlements,dim1*dim2);
    for i=1:amountsettlements
        [bla,I]=sort(reshape(squeeze(energymatrix2(:,:,i)),1,dim1*dim2));
        settleindices(i,:)=I;
    end
end



%number of simulations
sim=200

for s=1:sim
    progress=s/sim
    %draw parameters
    elbasetting4;
    oow=0;
    
    %initialize wood distributions
    WD1=zeros(4,nT);
    WD2=zeros(4,nT);
    WD3=zeros(4,nT);
    WD4=zeros(4,nT);
    WD5=zeros(4,nT);
    WD6=zeros(4,nT);
    WD7=zeros(4,nT);
    WD8=zeros(4,nT);
    WD9=zeros(4,nT);
    WD10=zeros(4,nT);
    WD11=zeros(4,nT);
    WD12=zeros(4,nT);
    WDtotal=zeros(4,nT);


    savefile='WD';
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %simulation

    for t=1:nT
        %simprogress=t/nT
        activesites=false(1,amountsites);
        for j=1:amountsites
            if stepsize*t+min(smeltingsites(:,1))<=smeltingsites(j,2) && stepsize*t+min(smeltingsites(:,1))>=smeltingsites(j,1)
                activesites(j)=true;
            end
        end

        %smelting site wood collection
        for j=1:amountsites
            if activesites(j)
                currentwood=0;
                index=[0,0];
                indexID=1;
                
                while currentwood<yearlywood_m3(j)

                    foundwood=0;
                    reset=0;
                    while foundwood==0
                        %if we checked all cells and still need wood break
                        if indexID>length(searchindices)-1
                            indexID=1;
                            reset=reset+1;
                            if reset==1
                                oow=1
                                break
                            end                            
                        end
                        %
                        [index1,index2]=ind2sub([dim1 dim2] , searchindices(j,indexID+1));
                        index=[index1 index2];
                        indexID=indexID+1;

                        wood_type = vegzonesnew(index(1),index(2));
                        wood_age = forestcells(index(1),index(2));
                        %is there wood?
                        if wood_type>0 && wood_type<5
                            %are the trees older than the rotation period
                            if wood_age>rotationperiod(wood_type)-1
                                foundwood=1;
                                
                            end
                        end
                    end
                    if oow==1
                        break                        
                    end
                    
                    if wood_age>42
                        %if the tree is older than 42, doesnt grow that
                        %much anymore (sigmoid growth)
                        wood_age=42;
                    end
                    
                    wood_vol=convert_ha_cell* woodmatrix(wood_type,wood_age); 
                    %wood that can be taken from a site of size 10mx10m
                    %number of trees per grid cell x amount of wood per tree of
                    %specific type and age
                    currentwood=currentwood+wood_vol;
                    forestcells(index(1),index(2))=0; 
                end

            end
            if oow==1
                break
            end
        end
        
        if oow==1
            break
        end
        
        %settlement wood collection
        if workforce==1
            activesettlements=false(1,amountsettlements);
            for j=1:amountsettlements
                if stepsize*t+min(settlements(:,3))<=settlements(j,4) && stepsize*t+min(settlements(:,3))>=settlements(j,3)
                    activesettlements(j)=true;
                end
            end
            if t>4

                forestbrowsej=forestbrowse(t)/sum(activesettlements);
            else
                forestbrowsej=0;
            end

            hhfuel_m3j=hhfuel_m3(t)/sum(activesettlements);

            for j=1:amountsettlements
                if activesettlements(j)
                    if t>4

                        forestbrowsej=forestbrowse(t)/sum(activesettlements);
                    end
                else
                    forestbrowsej=0;
                end
                currentwood=0;
                index=[0,0];
                indexID=1;
                while currentwood<hhfuel_m3j
                    foundwood=0;
                    while foundwood==0
                        [index1,index2]=ind2sub([dim1 dim2] , settleindices(j,indexID+1));
                        index=[index1 index2];
                        indexID=indexID+1;
                        if indexID+1>length(settleindices)
                            foundwood=1;
                            currentwood=hhfuel_m3j;
                            oow=oow+1;
                        end

                        wood_type = vegzonesnew(index(1),index(2));
                        wood_age = forestcells(index(1),index(2));
                        %is there wood?
                        if wood_type>0 && wood_type<5
                            %are the trees older than the rotation period
                            if wood_age>rotationperiod(wood_type)-1
                                foundwood=1;
                                %there is wood at the index, ie no wood is a false
                                %statement
                            elseif wood_age<5 && wood_type<4
                                if forestbrowsej>0
                                    forestbrowsej=forestbrowsej-1;
                                    forestcells(index(1),index(2))=forestcells(index(1),index(2))-stepsize;
                                end
                            end
                        end
                    end

                   
                    if isnan(wood_age)==false
                    wood_vol=convert_ha_cell* woodmatrix(wood_type,wood_age); 
                    %wood that can be taken from a site of size 10mx10m
                    %number of trees per grid cell x amount of wood per tree of
                    %specific type and age
                    currentwood=currentwood+wood_vol;
                    forestcells(index(1),index(2))=0;
                    end
                end
                while forestbrowsej>0
                    [index1,index2]=ind2sub([dim1 dim2] , settleindices(j,indexID+1));
                    index=[index1 index2];
                    indexID=indexID+1;

                    wood_type = vegzonesnew(index(1),index(2));
                    wood_age = forestcells(index(1),index(2));
                    %is there wood?
                    if wood_type>0 && wood_type<5

                        if wood_age<5 && wood_type<4
                            if forestbrowsej>0
                                forestbrowsej=forestbrowsej-10;
                                forestcells(index(1),index(2))=forestcells(index(1),index(2))-stepsize;
                            end
                        end
                    end
                end
            end      
        end
        %update wood distributions
        for i=1:dim1
            for j=1:dim2
                if elbaregions(i,j)==11
                   if forestcells(i,j)==0
                       WD1(1,t)=WD1(1,t)+1/r1;
                   elseif forestcells(i,j)<5
                       WD1(2,t)=WD1(2,t)+1/r1;
                   elseif forestcells(i,j)<42
                       WD1(3,t)=WD1(3,t)+1/r1;
                   else
                       WD1(4,t)=WD1(4,t)+1/r1;
                   end
                elseif elbaregions(i,j)==12

                    if forestcells(i,j)==0
                       WD2(1,t)=WD2(1,t)+1/r2;
                   elseif forestcells(i,j)<5
                       WD2(2,t)=WD2(2,t)+1/r2;
                   elseif forestcells(i,j)<42
                       WD2(3,t)=WD2(3,t)+1/r2;
                   else
                       WD2(4,t)=WD2(4,t)+1/r2;
                   end
                elseif elbaregions(i,j)==13
                    if forestcells(i,j)==0
                       WD3(1,t)=WD3(1,t)+1/r3;
                   elseif forestcells(i,j)<5
                       WD3(2,t)=WD3(2,t)+1/r3;
                   elseif forestcells(i,j)<42
                       WD3(3,t)=WD3(3,t)+1/r3;
                   else
                       WD3(4,t)=WD3(4,t)+1/r3;
                   end
                elseif elbaregions(i,j)==14
                    if forestcells(i,j)==0
                       WD4(1,t)=WD4(1,t)+1/r4;
                   elseif forestcells(i,j)<5
                       WD4(2,t)=WD4(2,t)+1/r4;
                   elseif forestcells(i,j)<42
                       WD4(3,t)=WD4(3,t)+1/r4;
                   else
                       WD4(4,t)=WD4(4,t)+1/r4;
                   end
                elseif elbaregions(i,j)==21
                    if forestcells(i,j)==0
                       WD5(1,t)=WD5(1,t)+1/r5;
                   elseif forestcells(i,j)<5
                       WD5(2,t)=WD5(2,t)+1/r5;
                   elseif forestcells(i,j)<42
                       WD5(3,t)=WD5(3,t)+1/r5;
                   else
                       WD5(4,t)=WD5(4,t)+1/r5;
                   end
                elseif elbaregions(i,j)==22
                    if forestcells(i,j)==0
                       WD6(1,t)=WD6(1,t)+1/r6;
                   elseif forestcells(i,j)<5
                       WD6(2,t)=WD6(2,t)+1/r6;
                   elseif forestcells(i,j)<42
                       WD6(3,t)=WD6(3,t)+1/r6;
                   else
                       WD6(4,t)=WD6(4,t)+1/r6;
                   end
                elseif elbaregions(i,j)==23
                    if forestcells(i,j)==0
                       WD7(1,t)=WD7(1,t)+1/r7;
                   elseif forestcells(i,j)<5
                       WD7(2,t)=WD7(2,t)+1/r7;
                   elseif forestcells(i,j)<42
                       WD7(3,t)=WD7(3,t)+1/r7;
                   else
                       WD7(4,t)=WD7(4,t)+1/r7;
                   end
                elseif elbaregions(i,j)==31
                    if forestcells(i,j)==0
                       WD8(1,t)=WD8(1,t)+1/r8;
                   elseif forestcells(i,j)<5
                       WD8(2,t)=WD8(2,t)+1/r8;
                   elseif forestcells(i,j)<42
                       WD8(3,t)=WD8(3,t)+1/r8;
                   else
                       WD8(4,t)=WD8(4,t)+1/r8;
                   end
                elseif elbaregions(i,j)==32
                    if forestcells(i,j)==0
                       WD9(1,t)=WD9(1,t)+1/r9;
                   elseif forestcells(i,j)<5
                       WD9(2,t)=WD9(2,t)+1/r9;
                   elseif forestcells(i,j)<42
                       WD9(3,t)=WD9(3,t)+1/r9;
                   else
                       WD9(4,t)=WD9(4,t)+1/r9;
                   end
                elseif elbaregions(i,j)==33
                    if forestcells(i,j)==0
                       WD10(1,t)=WD10(1,t)+1/r10;
                   elseif forestcells(i,j)<5
                       WD10(2,t)=WD10(2,t)+1/r10;
                   elseif forestcells(i,j)<42
                       WD10(3,t)=WD10(3,t)+1/r10;
                   else
                       WD10(4,t)=WD10(4,t)+1/r10;
                   end
                elseif elbaregions(i,j)==41
                    if forestcells(i,j)==0
                       WD11(1,t)=WD11(1,t)+1/r11;
                   elseif forestcells(i,j)<5
                       WD11(2,t)=WD11(2,t)+1/r11;
                   elseif forestcells(i,j)<42
                       WD11(3,t)=WD11(3,t)+1/r11;
                   else
                       WD11(4,t)=WD11(4,t)+1/r11;
                   end
                elseif elbaregions(i,j)==42
                    if forestcells(i,j)==0
                       WD12(1,t)=WD12(1,t)+1/r12;
                   elseif forestcells(i,j)<5
                       WD12(2,t)=WD12(2,t)+1/r12;
                   elseif forestcells(i,j)<42
                       WD12(3,t)=WD12(3,t)+1/r12;
                   else
                       WD12(4,t)=WD12(4,t)+1/r12;
                   end
                end
                if forestcells(i,j)==0
                   WDtotal(1,t)=WDtotal(1,t)+1/total;
                elseif forestcells(i,j)<5
                   WDtotal(2,t)=WDtotal(2,t)+1/total;
                elseif forestcells(i,j)<42
                   WDtotal(3,t)=WDtotal(3,t)+1/total;
                elseif forestcells(i,j)==42
                   WDtotal(4,t)=WDtotal(4,t)+1/total;
                end
                

            end
        end

        %wood regrowth
        %let each tree regrow by stepsize years
        for j=1:dim1
            for i=1:dim2
                if forestcells(j,i)<42
                    forestcells(j,i)=forestcells(j,i)+stepsize;
                end

            end
        end
        
        %for only one simulation save after every timestep current
        %vegetation
        if nsim==1
            forest_save=forestcells;
            save(['simulation/' savefile num2str(t/saveyears) '.mat'], 'forest_save')

        end

    end
    %save data after the simulation is complete
    save(['simulation10/' savefile num2str(s) '.mat'], 'oow','WD1','WD2','WD3','WD4','WD5','WD6','WD7','WD8','WD9','WD10','WD11','WD12', 'WDtotal','smeltingsites','furnace_efficiency_kg','kiln_efficiency_kg','yearlyslag','totalslag')

end


